<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;10444900">
	<META NAME="CHANGED" CONTENT="20070710;12195000">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Brute Force Parser –
Regular or Context Free Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Run Brute Force Parser on Regular or CFG</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">JFLAP defines a context free grammar G
= (V, T, S, P), where</P>
<P><I>V</I> is a set of variables (S represents the start
variable).<BR>T is a set of terminals.<BR>P is a set of productions.
<BR>Productions are in the form A-&gt;x, where A is a single variable
and x is a string of zero or more terminals and variables.</P>
<P STYLE="margin-bottom: 0in">Since JFLAP accepts context-free
grammars (CFG), it automatically works with regular grammars (thus,
right-linear grammar) as they are also context-free grammars. In a
right-linear grammar all productions must have at most one variable
in the right-hand side and this variable must be to the right of all
the terminals. 
</P>
<P><BR><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Run Brute Force Parser on Regular or CFG</H2>
<P><A NAME="language1"></A>We will begin by loading the grammar that
we entered in the previous tutorial. You can either enter the grammar
(shown in <B>Enter Grammar tutorial</B>) or load the file
<A HREF="contextfreeGrammar.jff">contextfreeGrammar.jff</A>. Then you
can click on <B>Input,</B> followed by <B>Brute Force Parse</B>.</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/bruteforceMenu.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in">After clicking <B>Brute Force Parse</B>,
you should see a window similar to this.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/bruteforceWindow.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now you can input a string
and check whether it is accepted. Enter the string “aabbbbbccc”
(a<SUP>2</SUP>b<SUP>5</SUP>c<SUP>3</SUP>) in the input text field.
Then either click <B>Start</B> or press <B>Enter key.</B></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Brute Force Parser notifies
you that the string you entered is accepted. Now, we can click on the
<B>Step</B> button to see how we can derive that string using our
productions. After clicking the <B>Step </B>button twice, your window
should look like this.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that at the bottom of
the window there is a message, “Derived bBc from B”. This message
tells us about the last production that was applied. We can also view
the <B>Derivation Table</B> to see how the string is derived by the
grammar. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">To
change to <B>Derivation Table </B>mode, click on <B>Noninverted Tree</B>
and select <B>Derivation Table</B><SPAN STYLE="text-decoration: none">.</SPAN>
The Brute Force Parse window should change to : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The derivation table shows
the productions that are applied (shown under Production) and the
result of applying those productions to the start variable (shown
under Derivation). It gives a clear picture of how Brute Force
Parsing is working. After clicking <B>Step </B>until we reach our
input string, the Brute Force Parse is finished and the <B>Derivation
Table </B><SPAN STYLE="font-weight: medium">and</SPAN><B> Noninverted
Tree </B>should look like these :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Brute Force Parser – Regular or CFG. Thanks for
reading!</B></P>
</BODY>
</HTML>